#include <Wire.h>
#include "Adafruit_LEDBackpack.h"
#include "Adafruit_GFX.h"

#define JOYSTICK_X_PIN A0
#define JOYSTICK_Y_PIN A1
#define BUTTON_PIN 2 // Broche où est connecté le bouton 2Pcs

Adafruit_8x8matrix matrix = Adafruit_8x8matrix(); // Utilisation de la classe Adafruit_8x8matrix pour la matrice LED
uint8_t x = 0;
uint8_t y = 0;

const int boutonPin1 = 8;
const int boutonPin2 = 3;
const int boutonPin3 = 4;
const int boutonPin4 = 6;
const int boutonPin5 = 7;
const int buzzerPin = 9;

int etatBouton1 = 0; 
int etatBouton2 = 0;
int etatBouton3 = 0; 
int etatBouton4 = 0; 
int etatBouton5 = 0; 

void setup() {
  Serial.begin(9600);
  Serial.println("Joystick and Buttons Test");

  matrix.begin(0x70); // Initialisation de la matrice LED
  pinMode(BUTTON_PIN, INPUT_PULLUP); // Bouton poussoir du joystick en entrée avec résistance de pull-up interne

  pinMode(boutonPin1, INPUT);  
  pinMode(boutonPin2, INPUT);  
  pinMode(boutonPin3, INPUT);  
  pinMode(boutonPin4, INPUT);  
  pinMode(boutonPin5, INPUT);  
  pinMode(buzzerPin, OUTPUT); // Met le buzzer en mode sortie

  digitalWrite(buzzerPin, LOW); 
}


void clearDisplay() {
  for (uint8_t i = 0; i < 8; i++) {
    matrix.displaybuffer[i] = 0;
  }
}



void loopJoystick() {
  int xValue = analogRead(JOYSTICK_X_PIN);
  int yValue = analogRead(JOYSTICK_Y_PIN);

  // Calibrer les valeurs de l'axe X et Y
  if (xValue < 400 && x > 0) {
    x--;
  } else if (xValue > 600 && x < 15) {
    x++;
  }

  if (yValue < 400 && y > 0) {
    y--;
  } else if (yValue > 600 && y < 7) {
    y++;
  }

  // Mettre à jour l'affichage
  clearDisplay();
  matrix.displaybuffer[y] |= (1 << x);
  matrix.writeDisplay();
  delay(200); // Ajouter un délai pour contrôler la vitesse du mouvement
}



void loopButtons() {
  // Lecture des états des boutons et contrôle du buzzer
  int etatBoutonActuel = digitalRead(boutonPin2);
  if (etatBoutonActuel != etatBouton2) {
    delay(50);
    etatBouton2 = etatBoutonActuel;
    if (etatBouton2 == LOW) {
      noTone(buzzerPin);
    } else {
      tone(buzzerPin, 293);
    }
  }

  int etatBoutonActuel1 = digitalRead(boutonPin1);
  if (etatBoutonActuel1 != etatBouton1) {
    delay(50);
    etatBouton1 = etatBoutonActuel1;
    if (etatBouton1 == LOW) {
      noTone(buzzerPin);
    } else {
      tone(buzzerPin, 261);
    }
  }

  int etatBoutonActuel2 = digitalRead(boutonPin3);
  if (etatBoutonActuel2 != etatBouton3) {
    delay(50);
    etatBouton3 = etatBoutonActuel2;
    if (etatBouton3 == LOW) {
      noTone(buzzerPin);
    } else {
      tone(buzzerPin, 329);
    }
  }

  int etatBoutonActuel3 = digitalRead(boutonPin4);
  if (etatBoutonActuel3 != etatBouton4) {
    delay(50);
    etatBouton4 = etatBoutonActuel3;
    if (etatBouton4 == LOW) {
      noTone(buzzerPin);
    } else {
      tone(buzzerPin, 348);
    }
  }

  int etatBoutonActuel4 = digitalRead(boutonPin5);
  if (etatBoutonActuel4 != etatBouton5) {
    delay(50);
    etatBouton5 = etatBoutonActuel4;
    if (etatBouton5 == LOW) {
      noTone(buzzerPin);
    } else {
      tone(buzzerPin, 392);
    }
  }
}



void loop() {
  
  loopButtons();
  loopJoystick();
  
}
